/// <reference types="node" />
import { Ora } from 'ora';
import { Metadata, MetadataSource } from '../core';
import { MetadataConfig } from '../core/core-config';
import { CliOptions } from './options';
export declare class CliTagger {
    cliOptions: CliOptions;
    metadataConfig: MetadataConfig;
    spinner: Ora;
    workingDir: string;
    metadataSource: MetadataSource;
    constructor(cliOptions: CliOptions, metadataConfig: MetadataConfig, spinner: Ora);
    getLocalCover(): Promise<Buffer>;
    getLocalJson(): Promise<Metadata[]>;
    downloadMetadata(album: string, cover?: Buffer): Promise<Metadata[]>;
    createFiles(metadata: Metadata[]): Promise<string[]>;
    writeMetadataToFile(metadata: Metadata[], targetFiles: string[]): Promise<void>;
    withRetry<T>(action: () => Promise<T>): Promise<T>;
    fetchMetadata(album: string): Promise<void>;
    run(album: string): Promise<void>;
}
