/// <reference types="node" />
import { MetadataSource } from '../metadata-source';
import { Metadata } from '../metadata';
import { MetadataConfig } from '../../core-config';
export type LocalJsonPlugin = (init: {
    cover?: Buffer;
    config: MetadataConfig;
}) => (context: {
    metadata: Metadata;
    index: number;
}) => void | Promise<void>;
export declare class LocalJson extends MetadataSource {
    private internalNormalize;
    normalize(metadatas: Metadata[], cover?: Buffer): Promise<Metadata[]>;
    normalizeWithoutCover(metadatas: Metadata[]): Promise<Metadata[]>;
    resolveAlbumName(localSource: string): Promise<string>;
    getMetadata(fullPath: string, cover?: Buffer): Promise<Metadata[]>;
}
export declare const localJson: LocalJson;
