"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.compressImage = void 0;
const os_1 = require("os");
const getQuality = (size) => Math.round(92.647 - 1.683e-6 * size);
const CompressedData = Symbol('CompressedData');
let imagePool;
const initImagePool = async () => {
    if (imagePool) {
        return;
    }
    const { ImagePool } = await Promise.resolve().then(() => __importStar(require('@squoosh/lib')));
    imagePool = new ImagePool((0, os_1.cpus)().length);
};
const compressImage = async (buffer, resolution) => {
    await initImagePool();
    if (buffer[CompressedData]) {
        return buffer[CompressedData];
    }
    const { default: imageInfo } = await Promise.resolve().then(() => __importStar(require('imageinfo')));
    const info = imageInfo(buffer);
    const resize = (() => {
        if (!resolution) {
            return undefined;
        }
        if (info.width > resolution) {
            return {
                width: resolution,
            };
        }
        if (info.height > resolution) {
            return {
                height: resolution,
            };
        }
        return undefined;
    })();
    const image = imagePool.ingestImage(buffer);
    await image.preprocess({
        resize,
    });
    const result = await image.encode({
        mozjpeg: {
            quality: getQuality(buffer.length),
        },
    });
    const resultBuffer = Buffer.from(result.mozjpeg.binary);
    buffer[CompressedData] = resultBuffer;
    return resultBuffer;
};
exports.compressImage = compressImage;
